#include "Fixed.hpp"
#include <iostream>

int main( void ) {
	{
		Fixed a(0);
		Fixed const b( Fixed( 5.05f ) * Fixed( 2 ) );
		std::cout << a << std::endl;
		std::cout << ++a << std::endl;
		std::cout << a << std::endl;
		std::cout << a++ << std::endl;
		std::cout << a << std::endl;
		std::cout << b << std::endl;
		std::cout << Fixed::max( a, b ) << std::endl;
	}
   	{
	// Créer deux objets Fixed pour les tests
    const Fixed a(2.5f);
    const Fixed b(1.3f);

    std::cout << "b: " << a << std::endl;
    std::cout << "a: " << b << std::endl;

    // Test de l'opérateur d'addition (+)
    Fixed sum = a + b;
    std::cout << "Addition: " << sum << std::endl;

    // Test de l'opérateur de soustraction (-)
    Fixed difference = a - b;
    std::cout << "Subtraction: " << difference << std::endl;

    // Test de l'opérateur de multiplication (*)
    Fixed product = a * b;
    std::cout << "Multiplication: " << product << std::endl;

    // Test de l'opérateur de division (/)
    Fixed quotient = a / b;
    std::cout << "Division: " << quotient << std::endl;

    // Test de l'opérateur de comparaison (==)
    bool isEqual = (a == b);
    std::cout << "Is a equal to b? " << std::boolalpha << isEqual << std::endl;

    // Test de l'opérateur de comparaison (!=)
    bool isNotEqual = (a != b);
    std::cout << "Is a not equal to b? " << std::boolalpha << isNotEqual << std::endl;

    // Test de l'opérateur de comparaison (<)
    bool isLessThan = (a < b);
    std::cout << "Is a less than b? " << std::boolalpha << isLessThan << std::endl;

    // Test de l'opérateur de comparaison (>)
    bool isGreaterThan = (a > b);
    std::cout << "Is a greater than b? " << std::boolalpha << isGreaterThan << std::endl;

    // Test de l'opérateur de comparaison (<=)
    bool isLessThanOrEqual = (a <= b);
    std::cout << "Is a less than or equal to b? " << std::boolalpha << isLessThanOrEqual << std::endl;

    // Test de l'opérateur de comparaison (>=)
    bool isGreaterThanOrEqual = (a >= b);
    std::cout << "Is a greater than or equal to b? " << std::boolalpha << isGreaterThanOrEqual << std::endl;
	}
    return 0;
}
